<template>
  <section class="py-5 px-4 grid grid-cols-products gap-2.5">
    <div v-for="data in products" :key="data" class="flex flex-col">
      <router-link
        :to="`/category/${category}/${data.id}`"
        class="cursor-pointer"
      >
        <img
          :src="data.thumbnail"
          alt="thumbnail"
          class="h-32 w-full object-cover border border-solid border-900 rounded-xl"
        />
        <span
          class="inline-block w-full my-2.5 font-normal overflow-hidden whitespace-nowrap text-ellipsis text-200 base:text-sm base:my-1.5"
          >{{ data.title }}</span
        >
        <span class="font-semibold text-lg text-200 base:text-base"
          >$ {{ data.price }}</span
        >
      </router-link>

      <div
        v-if="
          this.cart
            .map((d) => {
              return d.products.values().next().value;
            })
            ?.find((product) => product.id == data.id)
        "
        class="flex items-center justify-between flex-row py-[28px]"
      >
        <button
          @click="decrement(data)"
          class="flex items-center justify-center h-6 w-6 text-400 font-semibold rounded-full border border-400 hover:bg-400 hover:text-100 transition-all"
        >
          -
        </button>

        <div
          v-if="
            this.cart
              .map((d) => {
                return d.products.values().next().value;
              })
              ?.find((product) => product.id == data.id)
          "
        >
          <span class="font-semibold font-base">
            {{
              this.cart
                .map((d) => {
                  return d.products.values().next().value;
                })
                .find((product) => product.id == data.id)?.quantity
            }}
          </span>
        </div>

        <button
          @click="increment(data)"
          class="flex items-center justify-center h-6 w-6 text-100 bg-400 font-semibold rounded-full border border-400 hover:bg-100 hover:text-400 transition-all"
        >
          +
        </button>
      </div>

      <button
        v-else
        class="my-5 w-full h-10 border border-solid border-400 rounded-full font-semibold text-400 base:my-4 base:text-sm hover:bg-1200 ease-in-out duration-300"
        @click="addToCart(data.id)"
      >
        Tambah
      </button>
    </div>
  </section>
</template>

<script>
export default {
  name: "ListProduct",
  props: [
    "products",
    "category",
    "currency",
    "findvalue",
    "decrement",
    "cart",
    "increment",
    "addToCart",
  ],
};
</script>
